diff --git a/gcc/coverage.c b/gcc/coverage.c
index d662e8d..8c5d572 100644
--- a/gcc/coverage.c
+++ b/gcc/coverage.c
@@ -554,12 +554,12 @@ unsigned
 coverage_compute_profile_id (struct cgraph_node *n)
 {
   expanded_location xloc
-    = expand_location (DECL_SOURCE_LOCATION (n->symbol.decl));
+    = expand_location (DECL_SOURCE_LOCATION (n->decl));
   unsigned chksum = xloc.line;
 
   chksum = coverage_checksum_string (chksum, xloc.file);
   chksum = coverage_checksum_string
-    (chksum, IDENTIFIER_POINTER (DECL_ASSEMBLER_NAME (n->symbol.decl)));
+    (chksum, IDENTIFIER_POINTER (DECL_ASSEMBLER_NAME (n->decl)));
   if (first_global_object_name)
     chksum = coverage_checksum_string
       (chksum, first_global_object_name);
diff --git a/gcc/cp/call.c b/gcc/cp/call.c
index 3ed73b8..4746afe 100644
--- a/gcc/cp/call.c
+++ b/gcc/cp/call.c
@@ -6630,7 +6630,7 @@ mark_versions_used (tree fn)
   it_v = node_v->next;
   while (it_v != NULL)
     {
-      mark_used (it_v->this_node->symbol.decl);
+      mark_used (it_v->this_node->decl);
       it_v = it_v->next;
     }
 }
diff --git a/gcc/cp/decl2.c b/gcc/cp/decl2.c
index d5d2912..a074d78 100644
--- a/gcc/cp/decl2.c
+++ b/gcc/cp/decl2.c
@@ -1710,7 +1710,7 @@ maybe_make_one_only (tree decl)
           struct varpool_node *node = varpool_node_for_decl (decl);
 	  DECL_COMDAT (decl) = 1;
 	  /* Mark it needed so we don't forget to emit it.  */
-          node->symbol.forced_by_abi = true;
+          node->forced_by_abi = true;
 	  TREE_USED (decl) = 1;
 	}
     }
@@ -1808,7 +1808,7 @@ import_export_class (tree ctype)
 static bool
 var_finalized_p (tree var)
 {
-  return varpool_node_for_decl (var)->symbol.definition;
+  return varpool_node_for_decl (var)->definition;
 }
 
 /* DECL is a VAR_DECL or FUNCTION_DECL which, for whatever reason,
@@ -1825,14 +1825,14 @@ mark_needed (tree decl)
 	 functions can be marked reachable, just use the external
 	 definition.  */
       struct cgraph_node *node = cgraph_get_create_node (decl);
-      node->symbol.forced_by_abi = true;
+      node->forced_by_abi = true;
     }
   else if (TREE_CODE (decl) == VAR_DECL)
     {
       struct varpool_node *node = varpool_node_for_decl (decl);
       /* C++ frontend use mark_decl_references to force COMDAT variables
          to be output that might appear dead otherwise.  */
-      node->symbol.forced_by_abi = true;
+      node->forced_by_abi = true;
     }
 }
 
@@ -1942,7 +1942,7 @@ maybe_emit_vtables (tree ctype)
 	{
 	  current = varpool_node_for_decl (vtbl);
 	  if (last)
-	    symtab_add_to_same_comdat_group ((symtab_node) current, (symtab_node) last);
+	    symtab_add_to_same_comdat_group (current, last);
 	  last = current;
 	}
     }
@@ -3707,7 +3707,7 @@ collect_candidates_for_java_method_aliases (void)
 
   FOR_EACH_FUNCTION (node)
     {
-      tree fndecl = node->symbol.decl;
+      tree fndecl = node->decl;
 
       if (DECL_CLASS_SCOPE_P (fndecl)
 	  && TYPE_FOR_JAVA (DECL_CONTEXT (fndecl))
@@ -3740,7 +3740,7 @@ build_java_method_aliases (struct pointer_set_t *candidates)
 
   FOR_EACH_FUNCTION (node)
     {
-      tree fndecl = node->symbol.decl;
+      tree fndecl = node->decl;
 
       if (TREE_ASM_WRITTEN (fndecl)
 	  && pointer_set_contains (candidates, fndecl))
@@ -3921,7 +3921,7 @@ collect_all_refs (const char *source_file)
 static bool
 clear_decl_external (struct cgraph_node *node, void * /*data*/)
 {
-  DECL_EXTERNAL (node->symbol.decl) = 0;
+  DECL_EXTERNAL (node->decl) = 0;
   return false;
 }
 
@@ -4222,7 +4222,7 @@ cp_write_global_declarations (void)
 	      struct cgraph_node *node, *next;
 
 	      node = cgraph_get_node (decl);
-	      if (node->symbol.cpp_implicit_alias)
+	      if (node->cpp_implicit_alias)
 		node = cgraph_alias_target (node);
 
 	      cgraph_for_node_and_aliases (node, clear_decl_external,
@@ -4230,10 +4230,10 @@ cp_write_global_declarations (void)
 	      /* If we mark !DECL_EXTERNAL one of the symbols in some comdat
 		 group, we need to mark all symbols in the same comdat group
 		 that way.  */
-	      if (node->symbol.same_comdat_group)
-		for (next = cgraph (node->symbol.same_comdat_group);
+	      if (node->same_comdat_group)
+		for (next = cgraph (node->same_comdat_group);
 		     next != node;
-		     next = cgraph (next->symbol.same_comdat_group))
+		     next = cgraph (next->same_comdat_group))
 	          cgraph_for_node_and_aliases (next, clear_decl_external,
 					       NULL, true);
 	    }
@@ -4245,7 +4245,7 @@ cp_write_global_declarations (void)
 	  if (!DECL_EXTERNAL (decl)
 	      && decl_needed_p (decl)
 	      && !TREE_ASM_WRITTEN (decl)
-	      && !cgraph_get_node (decl)->symbol.definition)
+	      && !cgraph_get_node (decl)->definition)
 	    {
 	      /* We will output the function; no longer consider it in this
 		 loop.  */
diff --git a/gcc/cp/lambda.c b/gcc/cp/lambda.c
index a53e692..2b43e79 100644
--- a/gcc/cp/lambda.c
+++ b/gcc/cp/lambda.c
@@ -847,8 +847,8 @@ maybe_add_lambda_conv_op (tree type)
     {
       /* Put the thunk in the same comdat group as the call op.  */
       symtab_add_to_same_comdat_group
-	 ((symtab_node) cgraph_get_create_node (statfn),
-          (symtab_node) cgraph_get_create_node (callop));
+	 (cgraph_get_create_node (statfn),
+          cgraph_get_create_node (callop));
     }
   body = begin_function_body ();
   compound_stmt = begin_compound_stmt (0);
diff --git a/gcc/cp/method.c b/gcc/cp/method.c
index 4ac533e..1cd2031 100644
--- a/gcc/cp/method.c
+++ b/gcc/cp/method.c
@@ -386,8 +386,8 @@ use_thunk (tree thunk_fndecl, bool emit_p)
 				 this_adjusting, fixed_offset, virtual_value,
 				 virtual_offset, alias);
   if (DECL_ONE_ONLY (function))
-    symtab_add_to_same_comdat_group ((symtab_node) thunk_node,
-				     (symtab_node) funcn);
+    symtab_add_to_same_comdat_group (thunk_node,
+				     funcn);
 
   if (!this_adjusting
       || !targetm.asm_out.can_output_mi_thunk (thunk_fndecl, fixed_offset,
diff --git a/gcc/cp/optimize.c b/gcc/cp/optimize.c
index 1b524c3..c4ee848 100644
--- a/gcc/cp/optimize.c
+++ b/gcc/cp/optimize.c
@@ -339,7 +339,7 @@ maybe_clone_body (tree fn)
 	     virtual, it goes into the same comdat group as well.  */
 	  if (comdat_group)
 	    symtab_add_to_same_comdat_group
-	       ((symtab_node) cgraph_get_create_node (clone),
+	       (cgraph_get_create_node (clone),
 	        symtab_get_node (fns[0]));
 	}
       else if (alias)
diff --git a/gcc/cp/tree.c b/gcc/cp/tree.c
index 63ec7fa..3ac0348 100644
--- a/gcc/cp/tree.c
+++ b/gcc/cp/tree.c
@@ -3983,8 +3983,8 @@ cp_fix_function_decl_p (tree decl)
 
       /* Don't fix same_body aliases.  Although they don't have their own
 	 CFG, they share it with what they alias to.  */
-      if (!node || !node->symbol.alias
-	  || !vec_safe_length (node->symbol.ref_list.references))
+      if (!node || !node->alias
+	  || !vec_safe_length (node->ref_list.references))
 	return true;
     }
 
diff --git a/gcc/dbxout.c b/gcc/dbxout.c
index 1cc5d52..db50f09 100644
--- a/gcc/dbxout.c
+++ b/gcc/dbxout.c
@@ -2480,7 +2480,7 @@ dbxout_expand_expr (tree expr)
 	     return NULL, otherwise stabs might reference an undefined
 	     symbol.  */
 	  struct varpool_node *node = varpool_get_node (expr);
-	  if (!node || !node->symbol.definition)
+	  if (!node || !node->definition)
 	    return NULL;
 	}
       /* FALLTHRU */
diff --git a/gcc/dwarf2out.c b/gcc/dwarf2out.c
index fc1c3f2..1f91aea 100644
--- a/gcc/dwarf2out.c
+++ b/gcc/dwarf2out.c
@@ -15024,7 +15024,7 @@ reference_to_unused (tree * tp, int * walk_subtrees,
   else if (TREE_CODE (*tp) == VAR_DECL)
     {
       struct varpool_node *node = varpool_get_node (*tp);
-      if (!node || !node->symbol.definition)
+      if (!node || !node->definition)
 	return *tp;
     }
   else if (TREE_CODE (*tp) == FUNCTION_DECL
@@ -17702,7 +17702,7 @@ premark_types_used_by_global_vars_helper (void **slot,
       /* Ask cgraph if the global variable really is to be emitted.
          If yes, then we'll keep the DIE of ENTRY->TYPE.  */
       struct varpool_node *node = varpool_get_node (entry->var_decl);
-      if (node && node->symbol.definition)
+      if (node && node->definition)
 	{
 	  die->die_perennial_p = 1;
 	  /* Keep the parent DIEs as well.  */
diff --git a/gcc/gimple-fold.c b/gcc/gimple-fold.c
index e6baabf..e946333 100644
--- a/gcc/gimple-fold.c
+++ b/gcc/gimple-fold.c
@@ -67,7 +67,7 @@ can_refer_decl_in_current_unit_p (tree decl, tree from_decl)
       || TREE_CODE (from_decl) != VAR_DECL
       || !DECL_EXTERNAL (from_decl)
       || (flag_ltrans
-	  && symtab_get_node (from_decl)->symbol.in_other_partition))
+	  && symtab_get_node (from_decl)->in_other_partition))
     return true;
   /* We are concerned only about static/external vars and functions.  */
   if ((!TREE_STATIC (decl) && !DECL_EXTERNAL (decl))
@@ -78,7 +78,7 @@ can_refer_decl_in_current_unit_p (tree decl, tree from_decl)
      unit may be in separate DSO and the symbol may be hidden.  */
   if (DECL_VISIBILITY_SPECIFIED (decl)
       && DECL_EXTERNAL (decl)
-      && (!(snode = symtab_get_node (decl)) || !snode->symbol.in_other_partition))
+      && (!(snode = symtab_get_node (decl)) || !snode->in_other_partition))
     return false;
   /* When function is public, we always can introduce new reference.
      Exception are the COMDAT functions where introducing a direct
@@ -109,7 +109,7 @@ can_refer_decl_in_current_unit_p (tree decl, tree from_decl)
          The second is important when devirtualization happens during final
          compilation stage when making a new reference no longer makes callee
          to be compiled.  */
-      if (!node || !node->symbol.definition || node->global.inlined_to)
+      if (!node || !node->definition || node->global.inlined_to)
 	{
 	  gcc_checking_assert (!TREE_ASM_WRITTEN (decl));
 	  return false;
@@ -118,7 +118,7 @@ can_refer_decl_in_current_unit_p (tree decl, tree from_decl)
   else if (TREE_CODE (decl) == VAR_DECL)
     {
       vnode = varpool_get_node (decl);
-      if (!vnode || !vnode->symbol.definition)
+      if (!vnode || !vnode->definition)
 	{
 	  gcc_checking_assert (!TREE_ASM_WRITTEN (decl));
 	  return false;
diff --git a/gcc/gimplify.c b/gcc/gimplify.c
index 3b3adb3..1e00dce 100644
--- a/gcc/gimplify.c
+++ b/gcc/gimplify.c
@@ -962,7 +962,7 @@ unshare_body (tree fndecl)
 
   if (cgn)
     for (cgn = cgn->nested; cgn; cgn = cgn->next_nested)
-      unshare_body (cgn->symbol.decl);
+      unshare_body (cgn->decl);
 }
 
 /* Callback for walk_tree to unmark the visited trees rooted at *TP.
@@ -1005,7 +1005,7 @@ unvisit_body (tree fndecl)
 
   if (cgn)
     for (cgn = cgn->nested; cgn; cgn = cgn->next_nested)
-      unvisit_body (cgn->symbol.decl);
+      unvisit_body (cgn->decl);
 }
 
 /* Unconditionally make an unshared copy of EXPR.  This is used when using
diff --git a/gcc/ipa-cp.c b/gcc/ipa-cp.c
index 78dee15..5453f9b 100644
--- a/gcc/ipa-cp.c
+++ b/gcc/ipa-cp.c
@@ -293,11 +293,11 @@ ipa_lat_is_single_const (struct ipcp_lattice *lat)
 static inline bool
 edge_within_scc (struct cgraph_edge *cs)
 {
-  struct ipa_dfs_info *caller_dfs = (struct ipa_dfs_info *) cs->caller->symbol.aux;
+  struct ipa_dfs_info *caller_dfs = (struct ipa_dfs_info *) cs->caller->aux;
   struct ipa_dfs_info *callee_dfs;
   struct cgraph_node *callee = cgraph_function_node (cs->callee, NULL);
 
-  callee_dfs = (struct ipa_dfs_info *) callee->symbol.aux;
+  callee_dfs = (struct ipa_dfs_info *) callee->aux;
   return (caller_dfs
 	  && callee_dfs
 	  && caller_dfs->scc_no == callee_dfs->scc_no);
@@ -369,7 +369,7 @@ print_lattice (FILE * f, struct ipcp_lattice *lat,
 
 	  fprintf (f, " [from:");
 	  for (s = val->sources; s; s = s->next)
-	    fprintf (f, " %i(%i)", s->cs->caller->symbol.order,
+	    fprintf (f, " %i(%i)", s->cs->caller->order,
 		     s->cs->frequency);
 	  fprintf (f, "]");
 	}
@@ -399,7 +399,7 @@ print_all_lattices (FILE * f, bool dump_sources, bool dump_benefits)
 
       info = IPA_NODE_REF (node);
       fprintf (f, "  Node: %s/%i:\n", cgraph_node_name (node),
-	       node->symbol.order);
+	       node->order);
       count = ipa_get_param_count (info);
       for (i = 0; i < count; i++)
 	{
@@ -440,16 +440,16 @@ determine_versionability (struct cgraph_node *node)
   /* There are a number of generic reasons functions cannot be versioned.  We
      also cannot remove parameters if there are type attributes such as fnspec
      present.  */
-  if (node->symbol.alias || node->thunk.thunk_p)
+  if (node->alias || node->thunk.thunk_p)
     reason = "alias or thunk";
   else if (!node->local.versionable)
     reason = "not a tree_versionable_function";
   else if (cgraph_function_body_availability (node) <= AVAIL_OVERWRITABLE)
     reason = "insufficient body availability";
 
-  if (reason && dump_file && !node->symbol.alias && !node->thunk.thunk_p)
+  if (reason && dump_file && !node->alias && !node->thunk.thunk_p)
     fprintf (dump_file, "Function %s/%i is not versionable, reason: %s.\n",
-	     cgraph_node_name (node), node->symbol.order, reason);
+	     cgraph_node_name (node), node->order, reason);
 
   node->local.versionable = (reason == NULL);
 }
@@ -525,7 +525,7 @@ ipcp_cloning_candidate_p (struct cgraph_node *node)
       return false;
     }
 
-  if (!optimize_function_for_speed_p (DECL_STRUCT_FUNCTION (node->symbol.decl)))
+  if (!optimize_function_for_speed_p (DECL_STRUCT_FUNCTION (node->decl)))
     {
       if (dump_file)
         fprintf (dump_file, "Not considering %s for cloning; "
@@ -727,9 +727,9 @@ initialize_node_lattices (struct cgraph_node *node)
 	    set_all_contains_variable (plats);
 	}
       if (dump_file && (dump_flags & TDF_DETAILS)
-	  && !node->symbol.alias && !node->thunk.thunk_p)
+	  && !node->alias && !node->thunk.thunk_p)
 	fprintf (dump_file, "Marking all lattices of %s/%i as %s\n",
-		 cgraph_node_name (node), node->symbol.order,
+		 cgraph_node_name (node), node->order,
 		 disable ? "BOTTOM" : "VARIABLE");
     }
 
@@ -1422,7 +1422,7 @@ propagate_constants_accross_call (struct cgraph_edge *cs)
   int i, args_count, parms_count;
 
   callee = cgraph_function_node (cs->callee, &availability);
-  if (!callee->symbol.definition)
+  if (!callee->definition)
     return false;
   gcc_checking_assert (cgraph_function_with_gimple_body_p (callee));
   callee_info = IPA_NODE_REF (callee);
@@ -1435,7 +1435,7 @@ propagate_constants_accross_call (struct cgraph_edge *cs)
      parameter.  However, we might need to uncover a thunk from below a series
      of aliases first.  */
   alias_or_thunk = cs->callee;
-  while (alias_or_thunk->symbol.alias)
+  while (alias_or_thunk->alias)
     alias_or_thunk = cgraph_alias_target (alias_or_thunk);
   if (alias_or_thunk->thunk.thunk_p)
     {
@@ -1606,7 +1606,7 @@ devirtualization_time_bonus (struct cgraph_node *node,
       /* Only bare minimum benefit for clearly un-inlineable targets.  */
       res += 1;
       callee = cgraph_get_node (target);
-      if (!callee || !callee->symbol.definition)
+      if (!callee || !callee->definition)
 	continue;
       isummary = inline_summary (callee);
       if (!isummary->inlinable)
@@ -1619,7 +1619,7 @@ devirtualization_time_bonus (struct cgraph_node *node,
       else if (isummary->size <= MAX_INLINE_INSNS_AUTO / 2)
 	res += 15;
       else if (isummary->size <= MAX_INLINE_INSNS_AUTO
-	       || DECL_DECLARED_INLINE_P (callee->symbol.decl))
+	       || DECL_DECLARED_INLINE_P (callee->decl))
 	res += 7;
     }
 
@@ -1649,7 +1649,7 @@ good_cloning_opportunity_p (struct cgraph_node *node, int time_benefit,
 {
   if (time_benefit == 0
       || !flag_ipa_cp_clone
-      || !optimize_function_for_speed_p (DECL_STRUCT_FUNCTION (node->symbol.decl)))
+      || !optimize_function_for_speed_p (DECL_STRUCT_FUNCTION (node->decl)))
     return false;
 
   gcc_assert (size_cost > 0);
@@ -1826,7 +1826,7 @@ estimate_local_effects (struct cgraph_node *node)
 
   if (dump_file && (dump_flags & TDF_DETAILS))
     fprintf (dump_file, "\nEstimating effects for %s/%i, base_time: %i.\n",
-	     cgraph_node_name (node), node->symbol.order, base_time);
+	     cgraph_node_name (node), node->order, base_time);
 
   always_const = gather_context_independent_values (info, &known_csts,
 						    &known_binfos, &known_aggs,
@@ -2119,14 +2119,14 @@ propagate_constants_topo (struct topo_info *topo)
       if (!cgraph_function_with_gimple_body_p (node))
 	continue;
 
-      node_dfs_info = (struct ipa_dfs_info *) node->symbol.aux;
+      node_dfs_info = (struct ipa_dfs_info *) node->aux;
       /* First, iteratively propagate within the strongly connected component
 	 until all lattices stabilize.  */
       v = node_dfs_info->next_cycle;
       while (v)
 	{
 	  push_node_to_stack (topo, v);
-	  v = ((struct ipa_dfs_info *) v->symbol.aux)->next_cycle;
+	  v = ((struct ipa_dfs_info *) v->aux)->next_cycle;
 	}
 
       v = node;
@@ -2155,7 +2155,7 @@ propagate_constants_topo (struct topo_info *topo)
 	    if (!edge_within_scc (cs))
 	      propagate_constants_accross_call (cs);
 
-	  v = ((struct ipa_dfs_info *) v->symbol.aux)->next_cycle;
+	  v = ((struct ipa_dfs_info *) v->aux)->next_cycle;
 	}
     }
 }
@@ -2235,7 +2235,7 @@ ipcp_propagate_stage (struct topo_info *topo)
 				   ipa_get_param_count (info));
 	initialize_node_lattices (node);
       }
-    if (node->symbol.definition && !node->symbol.alias)
+    if (node->definition && !node->alias)
       overall_size += inline_summary (node)->self_size;
     if (node->count > max_count)
       max_count = node->count;
@@ -2303,8 +2303,8 @@ ipcp_discover_new_direct_edges (struct cgraph_node *node,
 		    fprintf (dump_file, "     controlled uses count of param "
 			     "%i bumped down to %i\n", param_index, c);
 		  if (c == 0
-		      && (to_del = ipa_find_reference ((symtab_node) node,
-						       (symtab_node) cs->callee,
+		      && (to_del = ipa_find_reference (node,
+						       cs->callee,
 						       NULL, 0)))
 		    {
 		      if (dump_file && (dump_flags & TDF_DETAILS))
@@ -2560,7 +2560,7 @@ update_profiling_info (struct cgraph_node *orig_node,
 	fprintf (dump_file, "    Problem: node %s/%i has too low count "
 		 HOST_WIDE_INT_PRINT_DEC " while the sum of incoming "
 		 "counts is " HOST_WIDE_INT_PRINT_DEC "\n",
-		 cgraph_node_name (orig_node), orig_node->symbol.order,
+		 cgraph_node_name (orig_node), orig_node->order,
 		 (HOST_WIDE_INT) orig_node_count,
 		 (HOST_WIDE_INT) (orig_sum + new_sum));
 
@@ -2693,13 +2693,13 @@ create_specialized_node (struct cgraph_node *node,
 					  args_to_skip, "constprop");
   ipa_set_node_agg_value_chain (new_node, aggvals);
   for (av = aggvals; av; av = av->next)
-    ipa_maybe_record_reference ((symtab_node) new_node, av->value,
+    ipa_maybe_record_reference (new_node, av->value,
 				IPA_REF_ADDR, NULL);
 
   if (dump_file && (dump_flags & TDF_DETAILS))
     {
       fprintf (dump_file, "     the new node is %s/%i.\n",
-	       cgraph_node_name (new_node), new_node->symbol.order);
+	       cgraph_node_name (new_node), new_node->order);
       if (aggvals)
 	ipa_dump_agg_replacement_values (dump_file, aggvals);
     }
@@ -3252,9 +3252,9 @@ perhaps_add_new_callers (struct cgraph_node *node, struct ipcp_value *val)
 		    fprintf (dump_file, " - adding an extra caller %s/%i"
 			     " of %s/%i\n",
 			     xstrdup (cgraph_node_name (cs->caller)),
-			     cs->caller->symbol.order,
+			     cs->caller->order,
 			     xstrdup (cgraph_node_name (val->spec_node)),
-			     val->spec_node->symbol.order);
+			     val->spec_node->order);
 
 		  cgraph_redirect_edge_callee (cs, val->spec_node);
 		  redirected_sum += cs->count;
@@ -3358,7 +3358,7 @@ decide_about_value (struct cgraph_node *node, int index, HOST_WIDE_INT offset,
 
   if (dump_file)
     fprintf (dump_file, "  Creating a specialized node of %s/%i.\n",
-	     cgraph_node_name (node), node->symbol.order);
+	     cgraph_node_name (node), node->order);
 
   callers = gather_edges_for_value (val, caller_count);
   kv = known_csts.copy ();
@@ -3395,7 +3395,7 @@ decide_whether_version_node (struct cgraph_node *node)
 
   if (dump_file && (dump_flags & TDF_DETAILS))
     fprintf (dump_file, "\nEvaluating opportunities for %s/%i.\n",
-	     cgraph_node_name (node), node->symbol.order);
+	     cgraph_node_name (node), node->order);
 
   gather_context_independent_values (info, &known_csts, &known_binfos,
 				  info->do_clone_for_all_contexts ? &known_aggs
@@ -3439,7 +3439,7 @@ decide_whether_version_node (struct cgraph_node *node)
       if (dump_file)
 	fprintf (dump_file, " - Creating a specialized node of %s/%i "
 		 "for all known contexts.\n", cgraph_node_name (node),
-		 node->symbol.order);
+		 node->order);
 
       callers = collect_callers_of_node (node);
       move_binfos_to_values (known_csts, known_binfos);
@@ -3514,23 +3514,23 @@ static void
 identify_dead_nodes (struct cgraph_node *node)
 {
   struct cgraph_node *v;
-  for (v = node; v ; v = ((struct ipa_dfs_info *) v->symbol.aux)->next_cycle)
+  for (v = node; v ; v = ((struct ipa_dfs_info *) v->aux)->next_cycle)
     if (cgraph_will_be_removed_from_program_if_no_direct_calls (v)
 	&& !cgraph_for_node_and_aliases (v,
 					 has_undead_caller_from_outside_scc_p,
 					 NULL, true))
       IPA_NODE_REF (v)->node_dead = 1;
 
-  for (v = node; v ; v = ((struct ipa_dfs_info *) v->symbol.aux)->next_cycle)
+  for (v = node; v ; v = ((struct ipa_dfs_info *) v->aux)->next_cycle)
     if (!IPA_NODE_REF (v)->node_dead)
       spread_undeadness (v);
 
   if (dump_file && (dump_flags & TDF_DETAILS))
     {
-      for (v = node; v ; v = ((struct ipa_dfs_info *) v->symbol.aux)->next_cycle)
+      for (v = node; v ; v = ((struct ipa_dfs_info *) v->aux)->next_cycle)
 	if (IPA_NODE_REF (v)->node_dead)
 	  fprintf (dump_file, "  Marking node as dead: %s/%i.\n",
-		   cgraph_node_name (v), v->symbol.order);
+		   cgraph_node_name (v), v->order);
     }
 }
 
@@ -3554,7 +3554,7 @@ ipcp_decision_stage (struct topo_info *topo)
 	{
 	  struct cgraph_node *v;
 	  iterate = false;
-	  for (v = node; v ; v = ((struct ipa_dfs_info *) v->symbol.aux)->next_cycle)
+	  for (v = node; v ; v = ((struct ipa_dfs_info *) v->aux)->next_cycle)
 	    if (cgraph_function_with_gimple_body_p (v)
 		&& ipcp_versionable_function_p (v))
 	      iterate |= decide_whether_version_node (v);
@@ -3627,7 +3627,7 @@ ipcp_generate_summary (void)
   FOR_EACH_FUNCTION_WITH_GIMPLE_BODY (node)
       {
 	node->local.versionable
-	  = tree_versionable_function_p (node->symbol.decl);
+	  = tree_versionable_function_p (node->decl);
 	ipa_analyze_node (node);
       }
 }
diff --git a/gcc/ipa-devirt.c b/gcc/ipa-devirt.c
index 2a50284..314efe2 100644
--- a/gcc/ipa-devirt.c
+++ b/gcc/ipa-devirt.c
@@ -543,9 +543,9 @@ build_type_inheritance_graph (void)
   /* We reconstruct the graph starting of types of all methods seen in the
      the unit.  */
   FOR_EACH_FUNCTION (n)
-    if (DECL_VIRTUAL_P (n->symbol.decl)
-	&& symtab_real_symbol_p ((symtab_node)n))
-      get_odr_type (method_class_type (TREE_TYPE (n->symbol.decl)), true);
+    if (DECL_VIRTUAL_P (n->decl)
+	&& symtab_real_symbol_p (n))
+      get_odr_type (method_class_type (TREE_TYPE (n->decl)), true);
   if (inheritance_dump_file)
     {
       dump_type_inheritance_graph (inheritance_dump_file);
@@ -570,7 +570,7 @@ maybe_record_node (vec <cgraph_node *> &nodes,
       && fcode != BUILT_IN_TRAP
       && !pointer_set_insert (inserted, target)
       && (target_node = cgraph_get_node (target)) != NULL
-      && symtab_real_symbol_p ((symtab_node)target_node))
+      && symtab_real_symbol_p (target_node))
     {
       pointer_set_insert (cached_polymorphic_call_targets,
 			  target_node);
@@ -856,7 +856,7 @@ dump_possible_polymorphic_call_targets (FILE *f,
 	   final ? " (full list)" : " (partial list, may call to other unit)");
   for (i = 0; i < targets.length (); i++)
     fprintf (f, " %s/%i", cgraph_node_name (targets[i]),
-	     targets[i]->symbol.order);
+	     targets[i]->order);
   fprintf (f, "\n");
 }
 
@@ -897,10 +897,10 @@ update_type_inheritance_graph (void)
   /* We reconstruct the graph starting of types of all methods seen in the
      the unit.  */
   FOR_EACH_FUNCTION (n)
-    if (DECL_VIRTUAL_P (n->symbol.decl)
-	&& !n->symbol.definition
-	&& symtab_real_symbol_p ((symtab_node)n))
-      get_odr_type (method_class_type (TREE_TYPE (n->symbol.decl)), true);
+    if (DECL_VIRTUAL_P (n->decl)
+	&& !n->definition
+	&& symtab_real_symbol_p (n))
+      get_odr_type (method_class_type (TREE_TYPE (n->decl)), true);
   timevar_pop (TV_IPA_INHERITANCE);
 }
 
@@ -914,13 +914,13 @@ likely_target_p (struct cgraph_node *n)
 {
   int flags;
   /* cxa_pure_virtual and similar things are not likely.  */
-  if (TREE_CODE (TREE_TYPE (n->symbol.decl)) != METHOD_TYPE)
+  if (TREE_CODE (TREE_TYPE (n->decl)) != METHOD_TYPE)
     return false;
-  flags = flags_from_decl_or_type (n->symbol.decl);
+  flags = flags_from_decl_or_type (n->decl);
   if (flags & ECF_NORETURN)
     return false;
   if (lookup_attribute ("cold",
-			DECL_ATTRIBUTES (n->symbol.decl)))
+			DECL_ATTRIBUTES (n->decl)))
     return false;
   if (n->frequency < NODE_FREQUENCY_NORMAL)
     return false;
@@ -950,7 +950,7 @@ ipa_devirt (void)
       bool update = false;
       if (dump_file && n->indirect_calls)
 	fprintf (dump_file, "\n\nProcesing function %s/%i\n",
-		 cgraph_node_name (n), n->symbol.order);
+		 cgraph_node_name (n), n->order);
       for (e = n->indirect_calls; e; e = e->next_callee)
 	if (e->indirect_info->polymorphic)
 	  {
@@ -975,8 +975,8 @@ ipa_devirt (void)
 		    if (dump_file)
 		      fprintf (dump_file,
 			       "Devirtualizing call in %s/%i to %s/%i\n",
-			       cgraph_node_name (n), n->symbol.order,
-			       cgraph_node_name (targets[0]), targets[0]->symbol.order);
+			       cgraph_node_name (n), n->order,
+			       cgraph_node_name (targets[0]), targets[0]->order);
 		    cgraph_make_edge_direct (e, targets[0]);
 		    ndevirtualized++;
 		    update = true;
@@ -1048,7 +1048,7 @@ ipa_devirt (void)
 		  }
 		continue;
 	      }
-	    if (!likely_target->symbol.definition)
+	    if (!likely_target->definition)
 	      {
 		if (dump_file)
 		  fprintf (dump_file, "Target is not an definition\n");
@@ -1059,7 +1059,7 @@ ipa_devirt (void)
 	       can handle these just well, it is common for programs to
 	       incorrectly with headers defining methods they are linked
 	       with.  */
-	    if (DECL_EXTERNAL (likely_target->symbol.decl))
+	    if (DECL_EXTERNAL (likely_target->decl))
 	      {
 		if (dump_file)
 		  fprintf (dump_file, "Target is external\n");
@@ -1068,7 +1068,7 @@ ipa_devirt (void)
 	      }
 	    if (cgraph_function_body_availability (likely_target)
 		<= AVAIL_OVERWRITABLE
-		&& symtab_can_be_discarded ((symtab_node) likely_target))
+		&& symtab_can_be_discarded (likely_target))
 	      {
 		if (dump_file)
 		  fprintf (dump_file, "Target is overwritable\n");
@@ -1080,11 +1080,11 @@ ipa_devirt (void)
 		if (dump_file)
 		  fprintf (dump_file,
 			   "Speculatively devirtualizing call in %s/%i to %s/%i\n",
-			   cgraph_node_name (n), n->symbol.order,
+			   cgraph_node_name (n), n->order,
 			   cgraph_node_name (likely_target),
-			   likely_target->symbol.order);
-		if (!symtab_can_be_discarded ((symtab_node) likely_target))
-		  likely_target = cgraph (symtab_nonoverwritable_alias ((symtab_node)likely_target));
+			   likely_target->order);
+		if (!symtab_can_be_discarded (likely_target))
+		  likely_target = cgraph (symtab_nonoverwritable_alias (likely_target));
 		nconverted++;
 		update = true;
 		cgraph_turn_edge_to_speculative
